<template>
  <div
    data-component-group="filter-forms"
    data-component="payment"
  >
    <FiltersForm
      :has-filters="hasFilters"
      @filter="onFilter"
      @clear="onClearFilters"
    >
      <v-text-field
        v-model="search"
        type="search"
        label="Search"
        prepend-inner-icon="search"
      />

      <v-autocomplete
        v-model="contract"
        :items="contracts"
        :filter="customIdFilter"
        type="number"
        :loading="isLoadingContracts"
        prepend-inner-icon="event"
        :return-object="true"
        item-text="id"
        label="Price contract ID"
        :menu-props="{nudgeBottom:'10'}"
        :search-input.sync="contractSearch"
      />

      <base-date-picker
        :date="date"
        placeholder="Created at"
        :config="dateConfig"
        :on-change="onChangeDate"
      />

      <v-autocomplete
        v-model="status"
        :items="statuses"
        :filter="customFilter"
        prepend-inner-icon="change_history"
        :return-object="true"
        item-text="name"
        label="Status"
        :menu-props="{nudgeBottom:'10'}"
      />
    </FiltersForm>
  </div>
</template>

<script>
  import uid from 'uid';
  import colors from 'vuetify/es5/util/colors';
  import stringEscape from 'js-string-escape';
  import FiltersForm from './Filters';
  import isDateRange from '../../../validators/dateRange';
  import { isNum, isNull, debounce } from '../../../utils';

  const debouncer = debounce({
    id: uid(),
    timeout: 500
  });

  // TODO: Translate component

  export default {
    components: {
      FiltersForm
    },
    data() {
      return {
        search: '',
        contract: {},
        contracts: [],
        contractSearch: '',
        date: '',
        status: {},
        dateConfig: {
          mode: 'range'
        },
        colors,
        isLoadingContracts: false
      };
    },
    computed: {
      hasFilters() {
        const { search, contract, date, status } = this;

        return search !== ''
          || isNum(contract.id)
          || date !== ''
          || isNum(status.id);
      },
      statuses() {
        return this.$store.getters['payments/statuses'];
      }
    },
    watch: {
      contractSearch(nextSearch) {
        if (!isNull(nextSearch)) {
          debouncer(() => this.getContracts(nextSearch));
        }
      }
    },
    created() {
      return this.$store.dispatch('payments/getStatuses');
    },
    methods: {
      getContracts(search = '') {
        const query = {
          per_page: -1,
          search
        };

        this.isLoadingContracts = true;
        return this.$store.dispatch('contracts/getItems', query)
          .then(({ items }) => {
            this.contracts = items;
            this.isLoadingContracts = false;
            return items;
          })
          .catch((err) => {
            this.isLoadingContracts = false;
            return err;
          });
      },
      onFilter() {
        const { search, contract, date, status } = this;
        const formattedSearch = stringEscape(search);
        const hasDate = date !== '';
        let nextDate = date;

        if (hasDate && !isDateRange(nextDate)) {
          nextDate = `${nextDate} - ${nextDate}`;
        }

        this.$emit('filter', {
          search: formattedSearch,
          contractId: contract.id,
          date: nextDate,
          status: status.id
        });
      },
      onClearFilters() {
        this.search = '';
        this.contract = {};
        this.date = '';
        this.status = {};

        this.$emit('clearFilters');
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      customIdFilter(item, queryText) {
        const textOne = item.id.toString().toLowerCase();
        const searchText = queryText.toString().toLowerCase();

        return textOne.indexOf(searchText) > -1;
      },
      onChangeDate(date) {
        this.date = date;
      }
    }
  };
</script>

<style lang="stylus" scoped>
  [data-component-group="filter-forms"] {
    &[data-component="payment"] {
      h1 {
        display: flex;
        align-items: center;
        margin: 0 0 32px 0;
        min-height: 48px;
      }
    }
  }
</style>
